
/* Copyright 2015 Haakan T. Johansson */

/*  This file is part of WIGSGLL.
 *
 *  WIGSGLL is free software: you can redistribute it and/or modify it
 *  under the terms of the GNU Lesser General Public License as
 *  published by the Free Software Foundation, either version 3 of the
 *  License, or (at your option) any later version.
 *
 *  WIGSGLL is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with WIGSGLL.  If not, see
 *  <http://www.gnu.org/licenses/>.
 */

#ifndef __WIGSGLL_CONFIG_H__
#define __WIGSGLL_CONFIG_H__

#include "wigsgll_auto_config.h"

/* Generate code for 'long double' results. */

#ifndef WIGSGLL_IMPL_LONG_DOUBLE    /* normally from wigsgll_auto_config.h */ 
#define WIGSGLL_IMPL_LONG_DOUBLE    0
#endif

/* Generate code for '__float128' results. */

#ifndef WIGSGLL_IMPL_FLOAT128       /* normally from wigsgll_auto_config.h */
#define WIGSGLL_IMPL_FLOAT128       0
#endif

/* Debug printing. */

#define DEBUG_PRINT                 0

/* Special rules for MSVC. */

#ifdef _MSC_VER

# define __thread         __declspec(thread)

# include <BaseTsd.h>
typedef SSIZE_T ssize_t;

#define WIGSGLL_NOINLINE  __declspec(noinline)

#endif

/* Avoid inlining of function. */

#ifndef WIGSGLL_NOINLINE
#define WIGSGLL_NOINLINE  __attribute__((noinline))
#endif

#endif/*__WIGSGLL_CONFIG_H__*/
