#include <stdio.h>

#include "wigsgll.h"

#define MAX_VALS  100

int main()
{
  double vals[MAX_VALS];
  double val9j;
  int two_min, two_max, two_i;
  int n, i;

  printf ("WIGSGLL C test program\n");

  /* Note that the arguments to wig3jj, wig6jj and wig9jj are 2*j
   * and 2*m.  To be able to handle half-integer arguments.
   */

  n = wig3jjqdjd(/* */   2* 15 , 2* 10 ,
		 /* */   2* 12 , 2*(-9),
		 vals, MAX_VALS,
		 &two_min, &two_max);

  for (i = 0, two_i = two_min; i < n; i++, two_i += 2)
    printf ("3J(%2d  15  10; -3  12  -9):      %#25.15f\n",
	    two_i/2, vals[i]);

  /* */

  n = wig6jjqdjd(/* */   2* 15 , 2* 10 ,
		 2*  7,  2*  7 , 2*  9 ,
		 vals, MAX_VALS,
                 &two_min, &two_max);

  for (i = 0, two_i = two_min; i < n; i++, two_i += 2)
    printf ("6J{%2d  15  10;  7   7   9}:      %#25.15f\n",
	    two_i/2, vals[i]);

  /* */

  n = wig9jjqdd(1,  2,  3,
		4,  6,  8,
		3,  6,  9,
		&val9j);

  printf ("9J{0.5 1 1.5; 2 3 4; 1.5 3 4.5}: %#25.15f\n", val9j);

  return 0;
}
