
/* Copyright 2023 Haakan T. Johansson */

/*  This file is part of WIGSGLL.
 *
 *  WIGSGLL is free software: you can redistribute it and/or modify it
 *  under the terms of the GNU Lesser General Public License as
 *  published by the Free Software Foundation, either version 3 of the
 *  License, or (at your option) any later version.
 *
 *  WIGSGLL is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with WIGSGLL.  If not, see
 *  <http://www.gnu.org/licenses/>.
 */

int FCN_POSTFIX(6,j,CALC_SUFFIX,CALC_SUFFIX)
  (int, int, int, int, int,
   CALC_TYPE *, size_t,
   int *, int *);

int FCN_POSTFIX(9,,CALC_SUFFIX,RETURN_SUFFIX)
  (
   int two_a, int two_b, int two_c,
   int two_d, int two_e, int two_f,
   int two_g, int two_h, int two_i,
   RETURN_TYPE *res
   )
{
  int two_kmin = max3(abs(two_h - two_d),
                      abs(two_b - two_f),
                      abs(two_a - two_i));
  int two_kmax = min3(two_h + two_d,
                      two_b + two_f,
                      two_a + two_i);
  int two_k;

  int two_jmax = max3(two_h + two_d,
                      two_b + two_f,
                      two_a + two_i);
  /* This is a bit excessive, but does not matter. */
  size_t max_entries = (size_t) (two_jmax / 2 + 1);

  CALC_TYPE sum_prod = 0;

  CALC_TYPE tmp[3][max_entries];

  int min0, min1, min2;
  int max0, max1, max2;

#if 0
  int has_sign =
    (two_j[0] + two_j[1] + two_j[2] +
     two_j[3] + two_j[4] + two_j[5] +
     two_j[6] + two_j[7] + two_j[8]) >> 1;

  sign = (((sign) & has_sign) /*^ tkmin*/) & 1;
#endif
  
#if 0
  printf ("- %d %d  %d %d %d\n",
	  /*  */ two_a, two_i,
	  two_c, two_f, two_b);
  printf ("- %d %d  %d %d %d\n",
	  /*  */ two_b, two_f,
	  two_e, two_d, two_h);
  printf ("- %d %d  %d %d %d\n",
	  /*  */ two_h, two_d,
	  two_g, two_a, two_i);
#endif
  
  FCN_POSTFIX(6,j,CALC_SUFFIX,CALC_SUFFIX)
    (/*  */ two_a, two_i,
     two_c, two_f, two_b,
     tmp[0], max_entries, &min0, &max0);
  FCN_POSTFIX(6,j,CALC_SUFFIX,CALC_SUFFIX)
    (/*  */ two_b, two_f,
     two_e, two_d, two_h,
     tmp[1], max_entries, &min1, &max1);
  FCN_POSTFIX(6,j,CALC_SUFFIX,CALC_SUFFIX)
    (/*  */ two_h, two_d,
     two_g, two_a, two_i,
     tmp[2], max_entries, &min2, &max2);

  int i0, i1, i2;

  i0 = (two_kmin - min0) / 2;
  i1 = (two_kmin - min1) / 2;
  i2 = (two_kmin - min2) / 2;

  for (two_k = two_kmin; two_k <= two_kmax; two_k += 2, i0++, i1++, i2++)
    {
      CALC_TYPE prod;

      prod = tmp[0][i0] * tmp[1][i1] * tmp[2][i2];

      sum_prod += ((1 - 2 * ((two_k) & 1)) * (two_k + 1)) * prod;

#if 0
      printf ("%3d  %20.15f %20.15f %20.15f  %20.15f  %20.15f\n",
	      two_k,
	      (double) tmp[0][i0],
	      (double) tmp[1][i1],
	      (double) tmp[2][i2],
	      (double) prod,
	      (double) sum_prod);
#endif
    }

  *res = (RETURN_TYPE) sum_prod;

  return 1;
}
