
/* Copyright 2023 Haakan T. Johansson */

/*  This file is part of WIGSGLL.
 *
 *  WIGSGLL is free software: you can redistribute it and/or modify it
 *  under the terms of the GNU Lesser General Public License as
 *  published by the Free Software Foundation, either version 3 of the
 *  License, or (at your option) any later version.
 *
 *  WIGSGLL is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with WIGSGLL.  If not, see
 *  <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>

#include "calc_minmax.h"
#include "wigsgll_error.h"
#include "wigsgll.h"
#include "wigsgll_avoid.h"

#include <stdlib.h>

#include <math.h>
#include <quadmath.h>

#define SQR(x) ((x)*(x))

/* Outer list (here) is over the return types.
 * The next list (in wigsgll_calcret.h) is over the types used
 * for calculations.
 * The inner list (in wigsgll_3jm6j.h) is over the iteration
 * order.
 * The actual routines (in wigsgll_inner.h) are then instantiated. 
 */

#define RETURN_TYPE    double
#define RETURN_SUFFIX  d
#include "wigsgll_calcret.h"
#undef  RETURN_TYPE
#undef  RETURN_SUFFIX

#define RETURN_TYPE    long double
#define RETURN_SUFFIX  ld
#include "wigsgll_calcret.h"
#undef  RETURN_TYPE
#undef  RETURN_SUFFIX

#define RETURN_TYPE    __float128
#define RETURN_SUFFIX  qd
#include "wigsgll_calcret.h"
#undef  RETURN_TYPE
#undef  RETURN_SUFFIX
