
/* Copyright 2023 Haakan T. Johansson */

/*  This file is part of WIGSGLL.
 *
 *  WIGSGLL is free software: you can redistribute it and/or modify it
 *  under the terms of the GNU Lesser General Public License as
 *  published by the Free Software Foundation, either version 3 of the
 *  License, or (at your option) any later version.
 *
 *  WIGSGLL is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with WIGSGLL.  If not, see
 *  <http://www.gnu.org/licenses/>.
 */

#include "wigsgll_error.h"

#include <stdlib.h>
#include <stdio.h>

#if PYWIGSGLL_ERROR_HANDLING

__thread jmp_buf _pywigsgll_jmp_env;

void wigsgll_error(void)
{
  /* Allow reuse of the temp array. */
  wigsgll_drop_temp();

  fprintf(stderr,
	  "\n"
	  "pywigsgll: Error detected! "
	  "** Library misuse?  See documentation. **\n"
	  "\n");

  longjmp(_pywigsgll_jmp_env, 1);
}

#else

void wigsgll_error(void)
{
  fprintf (stderr, "wigsgll: Abort.\n");
  exit(1);
}

#endif/*PYWIGSGLL_ERROR_HANDLING*/
