
/* Copyright 2023 Haakan T. Johansson */

/*  This file is part of WIGSGLL.
 *
 *  WIGSGLL is free software: you can redistribute it and/or modify it
 *  under the terms of the GNU Lesser General Public License as
 *  published by the Free Software Foundation, either version 3 of the
 *  License, or (at your option) any later version.
 *
 *  WIGSGLL is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with WIGSGLL.  If not, see
 *  <http://www.gnu.org/licenses/>.
 */

#ifndef __WIGSGLL_ERROR_H__
#define __WIGSGLL_ERROR_H__

#include "wigsgll_config.h"

void wigsgll_error(void);

#if PYWIGSGLL_ERROR_HANDLING

#include <setjmp.h>

extern __thread jmp_buf _pywigsgll_jmp_env;

# define PYWIGSGLL_ERROR_SETUP(x) do {	\
    if (setjmp(_pywigsgll_jmp_env))	\
      return x;				\
  } while (0)

void wigsgll_drop_temp(void);
#else
# define PYWIGSGLL_ERROR_SETUP(x) do { } while (0)
#endif

# define PYWIGSGLL_ERROR_SETUP_void  PYWIGSGLL_ERROR_SETUP()
# define PYWIGSGLL_ERROR_SETUP_NaN   PYWIGSGLL_ERROR_SETUP(strtof("NAN",NULL))

#endif/*__WIGSGLL_ERROR_H__*/
